﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Collections;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.DebugEngine {

  public class ExecutionStack : ObservableList<IOperation>, IContent, IDeepCloneable {

    public ExecutionStack() : base() { }
    public ExecutionStack(int capacity) : base(capacity) { }
    public ExecutionStack(IEnumerable<IOperation> collection) : base(collection) { }

    [StorableConstructor]
    protected ExecutionStack(bool deserializing) : base(deserializing) { }
    protected ExecutionStack(ExecutionStack original, Cloner cloner) {
      cloner.RegisterClonedObject(original, this);
      AddRange(original.Select(op => cloner.Clone(op)));
    }
    public object Clone() {
      return Clone(new Cloner());
    }
    public virtual IDeepCloneable Clone(Cloner cloner) {
      return new ExecutionStack(this, cloner);
    }
  }
}
